#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define PI 3.14159265358979

// vO̐
char *fname = "P4-07butterworth.c";
char *title = "o^[XtB^̃vO";

// ̓j[
char *menu[] = {
	" 1/7. 3Def[^̃t@C ",
	" 2/7. tB^̃t@C   ",
	" 3/7. ef[^̕           ",
	" 4/7. ef[^̍         ",
	" 5/7. ef[^̓e       ",
	" 6/7. JbgItg         ",
	" 7/7. iI[_[j         ",
};

// O[oϐ̐錾Əlݒ
char    g_f1[50] = "n4-05_0all.imv";  // 1Def[^̃t@C
char    g_f2[50] = "n4-07_0all.imv";  // 2Dč\摜̃t@C
int     g_px = 128;                   // 3Def[^̃r
int     g_pz = 128;                   // 4Def[^̃r
int     g_pa = 128;                   // 5. ef[^̓e
double  g_cf = 0.25;                  // 6Dč\摜̕
double  g_od = 4;                     // 7. č\摜̍

float*  g_prj;  // ef[^̈
float*  g_pri;  // ef[^̈ij
float*  g_btw;  // o^[XtB^                    

// vg^Cv錾
void butterworth(float*img, int nx, int ny, double cf, double od);
void read_data(char* fi, float* img, int size);
void write_data(char* fi, float* img, int size);
void fft2d(int ir, float* imr, float* imi, int nx, int ny);

// ^CgƓ̓j[̕\ƕϐւ̒l̓
void getparameter(void)
{
	int   i = 0;
	char  dat[256];

	// ^Cgƃt@C̕\
	printf("\n%s\n", title);
	printf("[ FileF%s ]\n\n", fname);

	// ϐւ̒l̓
	printf(" %s [%s] :", menu[i++], g_f1);
	if (*fgets(dat, 256, stdin) != '\n') { dat[strlen(dat) - 1] = 0; strcpy(g_f1, dat); }
	printf(" %s [%s] :", menu[i++], g_f2);
	if (*fgets(dat, 256, stdin) != '\n') { dat[strlen(dat) - 1] = 0; strcpy(g_f2, dat); }
	printf(" %s [%d] :", menu[i++], g_px);
	if (*fgets(dat, 256, stdin) != '\n')  g_px = atoi(dat);
	printf(" %s [%d] :", menu[i++], g_pz);
	if (*fgets(dat, 256, stdin) != '\n')  g_pz = atoi(dat);
	printf(" %s [%d] :", menu[i++], g_pa);
	if (*fgets(dat, 256, stdin) != '\n')  g_pa = atoi(dat);
	printf(" %s [%f] :", menu[i++], g_cf);
	if (*fgets(dat, 256, stdin) != '\n')  g_cf = atof(dat);
	printf(" %s [%f] :", menu[i++], g_od);
	if (*fgets(dat, 256, stdin) != '\n')  g_od = atof(dat);

	printf("\n");
}

int main(void)
{
	int i, j;

	getparameter();

	// 摜̈̊mۂƏ
	g_prj = (float*)malloc((size_t)g_px * g_pz * g_pa * sizeof(float));
	g_pri = (float*)malloc((size_t)g_px * g_pz * g_pa * sizeof(float));
	g_btw = (float*)malloc((size_t)g_px * g_pz * sizeof(float));
	for (i = 0; i < g_px * g_pz * g_pa; i++)
		g_pri[i] = 0;

	// ef[^̓ǂݏo
	read_data(g_f1, g_prj, g_px * g_pz * g_pa);

	// 2t[Gϊ
	for (i = 0; i < g_pa; i++)
		fft2d(1, g_prj + i * g_px * g_pz, g_pri + i * g_px * g_pz, g_px, g_pz);

	// o^[XtB^
	butterworth(g_btw, g_px, g_pz, g_cf, g_od);
	for (i = 0; i < g_pa; i++) {
		for (j = 0; j < g_px * g_pz; j++) {
			g_prj[i * g_px * g_pz + j] *= g_btw[j];
			g_pri[i * g_px * g_pz + j] *= g_btw[j];
		}
	}

	// 2t[Gtϊ
	for (i = 0; i < g_pa; i++)
		fft2d(-1, g_prj + i * g_px * g_pz, g_pri + i * g_px * g_pz, g_px, g_pz);

	// ef[^̕ۑ
	write_data(g_f2, g_prj, g_px * g_pz * g_pa);

	// 摜̈̊J
	free(g_prj);
	free(g_pri);
	free(g_btw);

	return 0;
}

// *** o^[XtB^ ***
// float  *btw;  // o^[XtB^摜
// int     nx;   // o^[XtB^̕
// int     ny;   // o^[XtB^̍
// double  cf;   // o^[XtB^̃JbgItg
// double  od;   // o^[XtB^̎iI[_[j
void butterworth(float* btw, int nx, int ny, double cf, double od)
{
	int  i, j;

	for (i = 0; i < ny; i++) {
		double y = (ny / 2 - i) / (double)ny;
		for (j = 0; j < nx; j++) {
			double x = (j - nx / 2) / (double)nx;
			double r = sqrt(x * x + y * y);
			btw[i * nx + j] = (float)(1 / (1 + pow(r / cf, 2 * od)));
		}
	}
}

// *** 摜f[^̓́ifloat^Ƃḗj***
// char *fi;    // ͉摜̃t@C
// float *img;  // ͉摜f[^
// int  size;   // ͉摜̃TCY
void read_data(char* fi, float* img, int size)
{
	FILE* fp;

	if ((fp = fopen(fi, "rb")) == NULL) {
		fprintf(stderr, " G[Ft@CJ܂[%s].\n", fi);
		exit(1);
	}
	fread(img, sizeof(float), size, fp);
	fclose(fp);
}

// *** 摜f[^̏óifloat^Ƃďój***
// char *fi;    // o͉摜̃t@C
// float *img;  // o͉摜f[^
// int  size;   // o͉摜̃TCY
void write_data(char* fi, float* img, int size)
{
	FILE* fp;

	if ((fp = fopen(fi, "wb")) == NULL) {
		fprintf(stderr, " G[Ft@CJ܂[%s].\n", fi);
		exit(1);
	}
	fwrite(img, sizeof(float), size, fp);
	fclose(fp);
}

// *** tB^OiRamptB^j ***
// float *prj;  // gԓef[^
// int    px;   // ef[^̃r
// int    pa;   // ef[^̓e
void filter(float* prj, int px, int pa)
{
	int     i, j;
	double  h0 = 0.25;

	// tB^̌_h0̌vZ
	for (i = 1; i < px / 2; i += 2)
		h0 -= 2.0 / (PI * PI * i * i);

	// tB^OiRamptB^j
	for (i = 0; i < pa; i++) {
		for (j = 0; j < px; j++) {
			double x = j - px / 2;
			double h = fabs(PI * x / px);  // ||̃tB^
			if (h == 0.0)  h = PI * h0;    // _̒l
			prj[i * px + j] *= (float)h;
		}
	}
}

// *** te ***
// float *img;  // 摜̈
// int    nx;   // 摜̈̕
// int    ny;   // 摜̈̍
// float *prj;  // ef[^
// int    px;   // ef[^̃r
// int    pa;   // ef[^̓e
void backprojection(float* img, int nx, int ny, float* prj, int px, int pa)
{
	int     i, j, k;

	// `ԗp̕ϐ
	int     ix0, ix1;
	double  dx0, dx1;

	// te
	for (k = 0; k < pa; k++) {
		double th = 2 * PI * k / pa;
		double si = sin(th);
		double co = cos(th);

		for (i = 0; i < ny; i++) {
			double y = ny / 2 - i;  // wWɕϊ
			for (j = 0; j < nx; j++) {
				double x = j - nx / 2;  // wWɕϊ
				double xx = x * co + y * si; // eʒui]j

				// 摜Wɕϊ
				xx += px / 2;
				// `Ԃ̏
				ix0 = (int)floor(xx);
				ix1 = ix0 + 1;
				if (ix0 < 0 || ix1 > px - 1) continue;
				dx0 = xx - ix0;
				dx1 = 1 - dx0;
				// `Ԃ̎s
				img[i * nx + j] += (float)(dx1 * prj[k * px + ix0] + dx0 * prj[k * px + ix1]);
			}
		}
	}

	// te̋Ki
	for (i = 0; i < nx * ny; i++)
		img[i] /= (float)pa;
}

// *** FFTɕKvȃf[^̍쐬iC]Cւpj***
// int     nx;        // 1FFT̃f[^
// double  *si;       // TCf[^   si[nx/2]
// double  *co;       // RTCf[^ co[nx/2]
// unsigned int *br;  // pf[^   brv[nx]
void FFTInit(int nx, double* si, double* co, unsigned int* br)
{
	int     i;
	double  dd = 2.0 * PI / nx;
	unsigned int  ur, ui, uc;

	// C]f[^̍쐬
	for (i = 0; i < nx / 2; i++) {
		si[i] = sin(dd * i);
		co[i] = cos(dd * i);
	}

	// ԓւpf[^̍쐬
	for (ui = 0; ui < (unsigned)nx; ui++) {
		ur = 0;
		for (uc = 1; uc <= (unsigned)nx / 2; uc <<= 1) {
			ur <<= 1;
			if ((ui & uc) != 0)
				ur++;
		}
		br[ui] = ur;
	}
}

/* 1t[GϊiFFTj */
// int     ir;        // ϊ(1)Ctϊ(-1)
// int     nx;        // 1FFT̃f[^
// double  *xr;       // ̃f[^   xr[nx]
// double  *xi;       // ̃f[^   xi[nx]
// double  *si;       // TCf[^   si[nx/2]
// double  *co;       // RTCf[^ co[nx/2]
// unsigned int *br;  // pf[^   br[nx]
void FFT(int ir, int nx, double* xr, double* xi, double* si, double* co, unsigned int* br)
{
	int     i, j, k, m, n1, n2 = nx, j3, j4, d = 1, g;
	double  a, b, c, s, tmp;

	// FFT̎sio^tCZj
	for (i = 1; i <= nx / 2; i *= 2, d += d) {
		g = 0;
		m = n2;
		n2 /= 2;
		for (k = 1; k <= n2; k++) {
			n1 = k - m;
			c = co[g];
			s = ir * si[g];
			g += d;
			for (j = m; j <= nx; j += m) {
				j3 = j + n1 - 1;
				j4 = j3 + n2;
				a = xr[j3] - xr[j4];
				b = xi[j3] - xi[j4];
				xr[j3] += xr[j4];
				xi[j3] += xi[j4];
				xr[j4] = c * a + s * b;
				xi[j4] = c * b - s * a;
			}
		}
	}

	// Ԃ̓ւ
	for (i = 0; i < nx; i++) {
		j = br[i];
		if (i < j) {
			tmp = xr[i];
			xr[i] = xr[j];
			xr[j] = tmp;
			tmp = xi[i];
			xi[i] = xi[j];
			xi[j] = tmp;
		}
	}

	// tϊ̏
	if (ir == -1) {
		for (i = 0; i < nx; i++) {
			xr[i] /= nx;
			xi[i] /= nx;
		}
	}
}

/* 2摜2t[GϊiFFT𗘗pj */
// int     ir;        // ϊ(1)Ctϊ(-1)
// float  *imr;       // ̃f[^   imr[nx*ny]
// float  *imi;       // ̃f[^   imi[nx*ny]
// int     nx;        // 摜f[^̕
// int     ny;        // 摜f[^̍
void fft2d(int ir, float* imr, float* imi, int nx, int ny)
{
	int     i, j;

	// FFTɗpf[^z̐錾
	double* xr, * xi, * si, * co;
	unsigned int* br;

	// x̔z̊m
	xr = (double*)malloc((size_t)nx * sizeof(double));
	xi = (double*)malloc((size_t)nx * sizeof(double));
	si = (double*)malloc((size_t)nx / 2 * sizeof(double));
	co = (double*)malloc((size_t)nx / 2 * sizeof(double));
	br = (unsigned int*)malloc((size_t)nx * sizeof(unsigned int));

	// FFTɕKvȃf[^̍쐬
	FFTInit(nx, si, co, br);

	// x̃t[Gϊ
	for (i = 0; i < ny; i++) {
		// f[^̓ւi_擪Ɉړj
		for (j = 0; j < nx / 2; j++) {
			xr[j] = imr[i * nx + j + nx / 2];
			xr[j + nx / 2] = imr[i * nx + j];
			xi[j] = imi[i * nx + j + nx / 2];
			xi[j + nx / 2] = imi[i * nx + j];
		}

		// FFT̎s
		FFT(ir, nx, xr, xi, si, co, br);

		// f[^̓ւi_𒆉ɖ߂j
		for (j = 0; j < nx / 2; j++) {
			imr[i * nx + j + nx / 2] = (float)xr[j];
			imr[i * nx + j] = (float)xr[j + nx / 2];
			imi[i * nx + j + nx / 2] = (float)xi[j];
			imi[i * nx + j] = (float)xi[j + nx / 2];
		}
	}
	// x̔z̉
	free(br);
	free(co);
	free(si);
	free(xi);
	free(xr);

	// y̔z̊m
	xr = (double*)malloc((size_t)ny * sizeof(double));
	xi = (double*)malloc((size_t)ny * sizeof(double));
	si = (double*)malloc((size_t)ny / 2 * sizeof(double));
	co = (double*)malloc((size_t)ny / 2 * sizeof(double));
	br = (unsigned int*)malloc((size_t)ny * sizeof(unsigned int));

	// FFTɕKvȃf[^̍쐬
	FFTInit(ny, si, co, br);

	// ỹt[Gϊ
	for (i = 0; i < nx; i++) {
		// f[^̓ւi_擪Ɉړj
		for (j = 0; j < ny / 2; j++) {
			xr[j] = imr[(j + ny / 2) * nx + i];
			xr[j + nx / 2] = imr[j * nx + i];
			xi[j] = imi[(j + ny / 2) * nx + i];
			xi[j + nx / 2] = imi[j * nx + i];
		}

		// FFT̎s
		FFT(ir, nx, xr, xi, si, co, br);

		// f[^̓ւi_𒆉ɖ߂j
		for (j = 0; j < nx / 2; j++) {
			imr[(j + ny / 2) * nx + i] = (float)xr[j];
			imr[j * nx + i] = (float)xr[j + nx / 2];
			imi[(j + ny / 2) * nx + i] = (float)xi[j];
			imi[j * nx + i] = (float)xi[j + nx / 2];
		}
	}
	// y̔z̉
	free(br);
	free(co);
	free(si);
	free(xi);
	free(xr);
}
