#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <direct.h>

#define PI 3.14159265358979

// vO̐
char* fname = "P4-23osem.c";
char* title = "OSEM@̃vO";

// ̓j[
char* menu[] = {
	" 1/8. ef[^̃t@C ",
	" 2/8. ef[^̃r     ",
	" 3/8. ef[^̓e     ",
	" 4/8. č\摜̃t@C ",
	" 5/8. č\摜̕         ",
	" 6/8. č\摜̍       ",
	" 7/8. TuZbg̐         ",
	" 8/8. JԂ           ",
};

// O[oϐ̐錾Əlݒ
char    g_f1[50] = "n4-07_2all.prj";  // 1Def[^̃t@C
int     g_px = 128;                   // 2Def[^̃r
int     g_pa = 128;                   // 3. ef[^̓e
char    g_f2[50] = "n4-23_0all.img";  // 4Dč\摜̃t@C
int     g_nx = 128;                   // 5Dč\摜̕
int     g_ny = 128;                   // 6. č\摜̍
int     g_ss = 8;                     // 7. TuZbg̐
int     g_nn = 10;                    // 8. JԂ

float* g_prj;                         // ef[^̈
float* g_img;                         // č\摜̈

// vg^Cv錾
void osem(float* img, int nx, int ny, float* prj, int px, int pa, int ss, int n);
void read_data(char* fi, float* img, int size);
void write_data(char* fi, float* img, int size);

// ^CgƓ̓j[̕\ƕϐւ̒l̓
void getparameter(void)
{
	int   i = 0;
	char  dat[256];

	// ^Cgƃt@C̕\
	printf("\n%s\n", title);
	printf("[ FileF%s ]\n\n", fname);

	// ϐւ̒l̓
	printf(" %s [%s] :", menu[i++], g_f1);
	if (*fgets(dat, 256, stdin) != '\n') { dat[strlen(dat) - 1] = 0; strcpy(g_f1, dat); }
	printf(" %s [%d] :", menu[i++], g_px);
	if (*fgets(dat, 256, stdin) != '\n')  g_px = atol(dat);
	printf(" %s [%d] :", menu[i++], g_pa);
	if (*fgets(dat, 256, stdin) != '\n')  g_pa = atoi(dat);
	printf(" %s [%s] :", menu[i++], g_f2);
	if (*fgets(dat, 256, stdin) != '\n') { dat[strlen(dat) - 1] = 0; strcpy(g_f2, dat); }
	printf(" %s [%d] :", menu[i++], g_nx);
	if (*fgets(dat, 256, stdin) != '\n')  g_nx = atol(dat);
	printf(" %s [%d] :", menu[i++], g_ny);
	if (*fgets(dat, 256, stdin) != '\n')  g_ny = atoi(dat);
	printf(" %s [%d] :", menu[i++], g_ss);
	if (*fgets(dat, 256, stdin) != '\n')  g_ss = atoi(dat);
	printf(" %s [%d] :", menu[i++], g_nn);
	if (*fgets(dat, 256, stdin) != '\n')  g_nn = atoi(dat);

	printf("\n");
}

int main(void)
{
	getparameter();

	// 摜̈̊mۂƏ
	g_prj = (float*)malloc((size_t)g_px * g_pa * sizeof(float));
	g_img = (float*)malloc((size_t)g_nx * g_ny * sizeof(float));

	// ef[^̓ǂݏo
	read_data(g_f1, g_prj, g_px * g_pa);

	// OSEM@
	osem(g_img, g_nx, g_ny, g_prj, g_px, g_pa, g_ss, g_nn);

	// ef[^̕ۑ
	write_data(g_f2, g_img, g_nx * g_ny);

	// 摜̈̊J
	free(g_prj);
	free(g_img);

	return 0;
}

// *** omCij̍쐬 ***
// float  *cij;  // ef[^
// int     px;   // e̕
// int     pa;   // e
// int     nx;   // 摜̕
// int     ny;   // 摜̍
void make_cij(float* cij, int px, int pa, int nx, int ny)
{
	int     i, j, k, ix;
	double  th, si, co, sia, coa, a, b, h, x, y, x0;
	double  a0, a1, a2, L;

	// 
	for (i = 0; i < px * pa * nx * ny; i++)
		cij[i] = 0;

	for (i = 0; i < pa; i++) {
		th = 2 * PI * i / pa;
		si = sin(th);
		co = cos(th);
		sia = fabs(si);
		coa = fabs(co);
		a = fabs(coa - sia) / 2;
		b = (coa + sia) / 2;
		h = coa > sia ? 1 / coa : 1 / sia;
		for (j = 0; j < ny; j++) {
			y = ny / 2 - j;
			for (k = 0; k < nx; k++) {
				x = k - nx / 2;
				x0 = x * co + y * si + px / 2;
				ix = (int)floor(x0 + 0.5);
				if (ix < 1 || ix > px - 2) continue;
				L = ix + 0.5 - x0;
				if (L <= a)     a2 = (a - L) * h + (b - a) * h / 2;
				else if (L < b) a2 = (b - L) * (b - L) * h / (2 * (b - a));
				else            a2 = 0;
				L = 1 - L;
				if (L <= a)     a0 = (a - L) * h + (b - a) * h / 2;
				else if (L < b) a0 = (b - L) * (b - L) * h / (2 * (b - a));
				else            a0 = 0;
				a1 = 1 - a0 - a2;
				cij[i * px * nx * ny + (ix - 1) * nx * ny + j * nx + k] += (float)a0;
				cij[i * px * nx * ny +  ix      * nx * ny + j * nx + k] += (float)a1;
				cij[i * px * nx * ny + (ix + 1) * nx * ny + j * nx + k] += (float)a2;
			}
		}
	}
}

// *** 1̓es֐ ***
// float*  prj;  // ef[^
// int     px;   // ef[^̕
// float*  img;  // 摜f[^
// int     nn;   // 摜f[^̃sNZ
// float*  cij;  // om
void forward_projection(float *prj, int px, float *img, int nn, float *cij) 
{
	int    i, j;

	for(i = 0 ; i < px ; i++) {
		for(j = 0 ; j < nn ; j++) {
			prj[i] += cij[i * nn + j] * img[j];
		}
	}
}

// *** 1ւ̋te߂֐ ***
// float*  img;  // 摜f[^
// int     nn;   // 摜f[^̃sNZ
// float*  prj;  // ef[^
// int     px;   // ef[^̕
// float*  cij;  // om
void back_projection(float* img, int nn, float* prj, int px, float* cij)
{
	int    i, j;

	for (i = 0; i < px; i++) {
		for (j = 0; j < nn; j++) {
			img[j] += cij[i * nn + j] * prj[i];
		}
	}
}

// *** ȅ߂CIS@ ***
// int*  cs; // CIS@̏
// int   ps; // e
void cis(int* cs, int pa)
{
	int    i, j, n;
	double e = 2.71828182846; // lCsA
	int    c = (int)(pa / e);
	int    mk = 0;

	cs[0] = mk;
	for (i = 1; i < pa; i++) {
		mk = (mk + c) % pa;
		do {
			n = 0;
			for (j = 0; j < i; j++) {
				if (cs[j] == mk) {
					mk = (mk + 1) % pa;
					break;
				}
				n++;
			}
		} while (n != i);
		cs[i] = mk;
	}
}

// *** OSEM@s֐ ***
// float   *img;  쐬摜f[^
// int     nx;    摜f[^̕ixj
// int     ny;    摜f[^̍iyj
// float   *prj;  ̓ef[^
// int     px;    ef[^̓a̐
// int     pa;    ef[^̊px̐
// int     ss;    TuZbg̐
// int     n;     JԂ
void osem(float* img, int nx, int ny, float* prj, int px, int pa, int ss, int n)
{
	int     i, j, k, m;
	char    fi[50];
	float*  cij, * cs0, * aprj, * rprj, * aimg;
	int*    cs;

	cij = (float*)malloc((size_t)px * pa * nx * ny * sizeof(float));
	cs0 = (float*)malloc((size_t)ss * nx * ny * sizeof(float));
	aprj = (float*)malloc((size_t)px * pa * sizeof(float));
	rprj = (float*)malloc((size_t)px * pa * sizeof(float));
	aimg = (float*)malloc((size_t)nx * ny * sizeof(float));
	cs = (int*)malloc((size_t)pa * sizeof(int));

	// ۑptH_̍쐬
	_mkdir("n4-23");

	// omcij̍쐬
	make_cij(cij, nx, ny, px, pa);

	// ef[^̒[̃G[ɘaiE5sNZj
	for (i = 0; i < pa; i++) {
		for (j = 0; j < 6; j++) {
			prj[i * px + j] *= (float)((cos(PI * (5 - j) / 5) + 1) / 2);
			prj[i * px + px - j - 1] *= (float)((cos(PI * (5 - j) / 5) + 1) / 2);
		}
	}

	// TuZbg̏iCIS@j
	cis(cs, pa);
	printf("CIS : ");
	for (i = 0; i < pa; i++)
		printf("%d, ", cs[i]);
	printf("\n\n");

	// OSEM itaration
	// omcij̋KiW̍쐬
	for (k = 0; k < ss; k++) {
		for (i = 0; i < nx * ny; i++) {
			cs0[k * nx * ny + i] = 0;
			for (j = k * pa / ss; j < (k + 1) * pa / ss; j++)
				for (m = 0; m < px; m++)
					cs0[k * nx * ny + i] += cij[(cs[j] * px + m) * nx * ny + i];
			if (cs0[k * nx * ny + i] == 0) cs0[k * nx * ny + i] = 1;
		}
	}
	write_data("n4-23_cs0.img", cs0+nx*ny, nx * ny);

	// @ 摜肷
	for (i = 0; i < nx * ny; i++)
		img[i] = 1;

	for (i = 0; i < n; i++) {
		fprintf(stderr, "\r *** OSEM iteration [%2d/%2d]", i + 1, n);
		for (j = 0; j < px * pa; j++) aprj[j] = rprj[j] = 0;
		for (k = 0; k < ss; k++) {
			for (j = 0; j < nx * ny; j++) aimg[j] = 0;
			// A 摜瓊evZ
			for (j = k * pa / ss; j < (k + 1) * pa / ss; j++)
				forward_projection(aprj + cs[j] * px, px, img, nx * ny, cij + cs[j] * px * nx * ny);
			// B e̔vZ
			for (j = 0; j < px * pa; j++)
				if (aprj[j] > 1)  rprj[j] = prj[j] / aprj[j];
			// C te
			for (j = k * pa / ss; j < (k + 1) * pa / ss; j++)
				back_projection(aimg, nx * ny, rprj + cs[j] * px, px, cij + cs[j] * px * nx * ny);
			// D Kiĉ摜XV
			for (j = 0; j < nx * ny; j++)
				img[j] *= aimg[j] / cs0[k * nx * ny + j];
		}
		// r摜̏o
		sprintf(fi, "n4-23/n4-23_0img%03d.img", i + 1);
		write_data(fi, img, nx * ny);
		sprintf(fi, "n4-23/n4-23_1aprj%03d.prj", i + 1);
		write_data(fi, aprj, px * pa);
		sprintf(fi, "n4-23/n4-23_2rprj%03d.prj", i + 1);
		write_data(fi, rprj, px * pa);
		sprintf(fi, "n4-23/n4-23_3aimg%03d.img", i + 1);
		write_data(fi, aimg, nx * ny);
	}
	printf("\n");
	free(cij);
	free(cs0);
	free(aprj);
	free(rprj);
	free(aimg);
}

// *** 摜f[^̓́ifloat^Ƃḗj***
// char *fi;    // ͉摜̃t@C
// float *img;  // ͉摜f[^
// int  size;   // ͉摜̃TCY
void read_data(char* fi, float* img, int size)
{
	FILE* fp;

	if ((fp = fopen(fi, "rb")) == NULL) {
		fprintf(stderr, " G[Ft@CJ܂[%s].\n", fi);
		exit(1);
	}
	fread(img, sizeof(float), size, fp);
	fclose(fp);
}

// *** 摜f[^̏óifloat^Ƃďój***
// char *fi;    // o͉摜̃t@C
// float *img;  // o͉摜f[^
// int  size;   // o͉摜̃TCY
void write_data(char* fi, float* img, int size)
{
	FILE* fp;

	if ((fp = fopen(fi, "wb")) == NULL) {
		fprintf(stderr, " G[Ft@CJ܂[%s].\n", fi);
		exit(1);
	}
	fwrite(img, sizeof(float), size, fp);
	fclose(fp);
}
